/*|--------------------------------------------------------------------------

 MAGELLAN X Window Input Extension  Application         Version 3.00 25.04.95

 Logitech Inc.
 6505 Kaiser Drive
 Fremont, CA 94555-3615

 Volker Senft:

 Main:   (510) 795-8500
 Direct: (510) 713-4055
 Sales:  (800) 231-7717
 Fax:    (510) 505-0979

----------------------------------------------------------------------------|*/
#include <stdlib.h>
#include <stdio.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/extensions/XInput.h>


#define FALSE  (1==0)
#define TRUE   (1==1)

int main( argc, argv )
int argc;
char *argv[];
{
Display *display;
Window root, window;

int screennumber,width,height;
XSizeHints *sizehints;
XWMHints *wmhints;
XClassHint *classhints;

char *WinName = "Magellan 3D Controller  X Input Extension";
XTextProperty WindowName;
GC wingc;
XGCValues xgcvalues;

XEvent Event;

XComposeStatus compose;
KeySym keysym;

int MagellanDemoEnd = FALSE;
char MagellanBuffer[ 256 ];

int MagellanID, DeviceNumber, loop;
XDeviceInfo *DeviceInfo;
XDevice *Device;
int MagellanMotionEventType, MagellanButtonPressEventType, MagellanButtonReleaseEventType;
int MagellanMotionEventClass, MagellanButtonPressEventClass, MagellanButtonReleaseEventClass;
XEventClass ListOfEventClass[3];
XDeviceButtonEvent *ButtonPtr;
XDeviceMotionEvent *MotionPtr;

XAxisInfoPtr XAxisPtr;
XAnyClassPtr XClassPtr;
int class, axis, axes;

XExtensionVersion *ExtVersion;

XFeedbackState *MagellanFeedback;
int FeedbackNumber;

/****************** Open a Window ******************************************/
 sizehints  = XAllocSizeHints();
 wmhints    = XAllocWMHints();
 classhints = XAllocClassHint();
 if ( (sizehints==NULL) || (wmhints==NULL) || (classhints==NULL) )
  {
   fprintf( stderr, "Can't allocate memory! Exit ... \n" );
   exit( -1 );
  };

 display = XOpenDisplay( NULL );
 if ( display == NULL )
  {
   fprintf( stderr, "Can't open display! Exit ... \n");
   exit( -1 );
  };

 screennumber = DefaultScreen(display);
 width  = DisplayWidth(display,screennumber);
 height = DisplayHeight(display,screennumber);
 root   = DefaultRootWindow(display);
 window = XCreateSimpleWindow( display, root, 0,0, width/5*3,height/8, 20,
			       BlackPixel(display,screennumber),
			       WhitePixel(display,screennumber) );

 XStringListToTextProperty( &WinName, 1, &WindowName );

 wmhints->initial_state = NormalState;
 wmhints->input = TRUE;
 wmhints->flags = StateHint | InputHint;

 classhints->res_name = "Magellan 3D Controller";
 classhints->res_class = "BasicWindow";
 XSetWMProperties( display, window, &WindowName, NULL, argv,
		   argc, sizehints, wmhints, classhints );

 XMapWindow( display, window ); 

 xgcvalues.foreground = BlackPixel( display, 0 );
 xgcvalues.background = WhitePixel( display, 0 );
 wingc = XCreateGC( display, window, GCForeground | GCBackground, &xgcvalues );


 ExtVersion = XGetExtensionVersion( display, "XInputExtension" );
 if ( (ExtVersion == NULL) || ((int)ExtVersion == NoSuchExtension) )
  {
   fprintf( stderr, "Cannot access X Input Extension. Exit ... \n");
   exit( -1 );
  };
 printf("X Input Extension Version %d.%d \n", ExtVersion->major_version, ExtVersion->minor_version );
 XFree( ExtVersion );

 DeviceInfo = XListInputDevices( display, &DeviceNumber );
 MagellanID = -1;
 for ( loop=0; loop<DeviceNumber; ++loop )
  {
   printf("------------------------------------------------------------------------\n");
   printf(" Type = %d \n", DeviceInfo[loop].type );
   printf("Device Name = %s Type = %d Atom = %s \n", DeviceInfo[loop].name,
           DeviceInfo[loop].type, XGetAtomName(display,DeviceInfo[loop].type) );
   printf(" Device Class(es) = %d  Use = %s \n", DeviceInfo[loop].num_classes,
            DeviceInfo[loop].use ? "TRUE" : "FALSE" );

   XClassPtr = (XAnyClassPtr) DeviceInfo[loop].inputclassinfo;
   for ( class=0; class<DeviceInfo[loop].num_classes; ++class )
    {
     switch( XClassPtr->class )
      {
       case 0: 
        printf("  Keyboard  Keycode Min = %d Max = %d  Number of Keys = %d \n",
                  ((XKeyInfo *)XClassPtr)->min_keycode,
                  ((XKeyInfo *)XClassPtr)->max_keycode,
                  ((XKeyInfo *)XClassPtr)->num_keys );
        break;

       case 1:
        printf("  Button(s)  Number of Buttons = %d \n", 
                  ((XButtonInfo *)XClassPtr)->num_buttons );
        break;

       case 2:
        printf("  Valuator(s)  Axes = %d  Mode = %d  Motion Buffer = %d \n",
                  ((XValuatorInfo *)XClassPtr)->num_axes,
                  ((XValuatorInfo *)XClassPtr)->mode,
                  ((XValuatorInfo *)XClassPtr)->motion_buffer );
        XAxisPtr = ((XValuatorInfo *)XClassPtr)->axes;
        axes = ((XValuatorInfo *)XClassPtr)->num_axes;
        for ( axis=0; axis<axes; ++axis )
         {
          printf("   Valuator = %d  Min = %d Max = %d  Resolution = %d \n", axis+1,
                     XAxisPtr->min_value, XAxisPtr->max_value, XAxisPtr->resolution );
          ++XAxisPtr;
         };
        break;

       default: 
        printf("  Class ID = %d  Length = %d \n", XClassPtr->class, XClassPtr->length );
        break;
      };  
     XClassPtr = (XAnyClassPtr) ((char *)XClassPtr+XClassPtr->length);
    };
  };

 for ( loop=0; loop<DeviceNumber; ++loop )
  {
   if ( strcmp( DeviceInfo[loop].name, "MAGELLAN" ) == NULL ||
        strcmp( DeviceInfo[loop].name, "magellan" ) == NULL )
    {
     MagellanID = DeviceInfo[loop].id;
     break;
    };
  };
 if ( MagellanID == -1 )
  {
   for ( loop=0; loop<DeviceNumber; ++loop )
    {
     if ( strcmp( DeviceInfo[loop].name, "SPACEBALL" ) == NULL ||
          strcmp( DeviceInfo[loop].name, "spaceball" ) == NULL )
      MagellanID = DeviceInfo[loop].id;
    };
  };

 XFreeDeviceList( DeviceInfo );
 printf("------------------------------------------------------------------------\n");
 printf("\n\n");

 if ( MagellanID == -1 )
  {
   printf("Magellan X Input Extension. \nCan't find Magellan. Exit ... \n" );
   exit( -1 );
  }
 else
  printf("Magellan X Input Extension ID = %d \n", MagellanID );

 Device = XOpenDevice( display, MagellanID );
 if ( Device == 0 )
  {
   printf("Magellan X Input Extension. \nCan't open Magellan. Exit ... \n" );
   exit( -1 );
  };

 DeviceMotionNotify( Device, MagellanMotionEventType, MagellanMotionEventClass );
 DeviceButtonPress( Device, MagellanButtonPressEventType, MagellanButtonPressEventClass );
 DeviceButtonRelease( Device, MagellanButtonReleaseEventType, MagellanButtonReleaseEventClass );

 printf("MotionNotify  Type=%d Class=%d \n", MagellanMotionEventType, MagellanMotionEventClass );
 printf("ButtonPress   Type=%d Class=%d \n", MagellanButtonPressEventType, MagellanButtonPressEventClass );
 printf("ButtonRelease Type=%d Class=%d \n", MagellanButtonReleaseEventType, MagellanButtonReleaseEventClass );

 ListOfEventClass[0] = MagellanMotionEventClass;
 ListOfEventClass[1] = MagellanButtonPressEventClass;
 ListOfEventClass[2] = MagellanButtonReleaseEventClass;

 XSelectExtensionEvent( display, window, ListOfEventClass, 3 );

 MagellanFeedback = XGetFeedbackControl( display, Device, &FeedbackNumber );
 printf("Magellan Feedback Number = %d \n", FeedbackNumber );
 for ( loop=0; loop<FeedbackNumber; ++loop )
  {
   printf("Feedback = %d  Class = %d  Length = %d  ID = %d \n", loop+1, MagellanFeedback->class, 
           MagellanFeedback->length, MagellanFeedback->id );
   switch( MagellanFeedback->class )
    {
     case KbdFeedbackClass:
      printf(" KbdFeedbackClass  Bell Volume = %d  Pitch = %d  Duration = %d   \n",
              ((XKbdFeedbackState *)MagellanFeedback)->percent,
              ((XKbdFeedbackState *)MagellanFeedback)->pitch,
              ((XKbdFeedbackState *)MagellanFeedback)->duration );
      break;

     case BellFeedbackClass:
      printf(" BellFeedbackClass  Bell Volume = %d  Pitch = %d  Duration = %d   \n",
              ((XBellFeedbackState *)MagellanFeedback)->percent,
              ((XBellFeedbackState *)MagellanFeedback)->pitch,
              ((XBellFeedbackState *)MagellanFeedback)->duration );
      break;

     case PtrFeedbackClass:
      printf(" PtrFeedbackClass   \n");
      break;

     case IntegerFeedbackClass:
      printf(" IntegerFeedbackClass   \n");
      break;

     case StringFeedbackClass:
      printf(" StringFeedbackClass   \n");
      break;

     case LedFeedbackClass:
      printf(" LedFeedbackClass   \n");
      break;

     default:
      printf(" Unkonw FeedbackClass \n");
    };
   MagellanFeedback = (XFeedbackState *)((char *)MagellanFeedback+MagellanFeedback->length);
  };

/************************* Main Loop ***************************************/
 XSelectInput( display, window, KeyPressMask | KeyReleaseMask );

 while( MagellanDemoEnd == FALSE )
  {
   XNextEvent( display, &Event );

   switch( Event.type )
    {
     case KeyRelease : /* ... */
                       break;
 
     case KeyPress :
      XLookupString( (XKeyEvent*)&Event, MagellanBuffer,
     		     sizeof(MagellanBuffer), &keysym, &compose );
      MagellanDemoEnd = keysym == XK_Escape;
      break;

     default :
      if ( Event.type == MagellanMotionEventType )
       {
	MotionPtr = (XDeviceMotionEvent *) &Event;

	if ( (MotionPtr->axes_count == 6) && (MotionPtr->first_axis == 0) )
	 {
          sprintf( MagellanBuffer, 
            "x=%+5.0lf y=%+5.0lf z=%+5.0lf a=%+5.0lf b=%+5.0lf c=%+5.0lf   ",
		 (double) MotionPtr->axis_data[ 0 ],
		 (double) MotionPtr->axis_data[ 1 ],
		 (double) MotionPtr->axis_data[ 2 ],
		 (double) MotionPtr->axis_data[ 3 ],
		 (double) MotionPtr->axis_data[ 4 ],
		 (double) MotionPtr->axis_data[ 5 ] );
          XClearWindow( display, window );
	  XDrawString( display, window, wingc, 10,40,
	  	       MagellanBuffer, (int)strlen(MagellanBuffer) );
	 }; 
       };
      
      if ( Event.type == MagellanButtonPressEventType )
       {
	ButtonPtr = (XDeviceButtonEvent *) &Event;
        sprintf( MagellanBuffer, "Button pressed [%c] %d  ",
		   ButtonPtr->button == 9 ? '*' : '0'+ButtonPtr->button, ButtonPtr->button );
        XClearWindow( display, window );
        XDrawString( display, window, wingc, 10,40,
                       MagellanBuffer, (int)strlen(MagellanBuffer) );
        XDeviceBell( display, Device, BellFeedbackClass, 0, 100 );
       };
      
      if ( Event.type == MagellanButtonReleaseEventType )
       {
	ButtonPtr = (XDeviceButtonEvent *) &Event;
        sprintf( MagellanBuffer, "Button released [%c] %d  ",
		   ButtonPtr->button == 9 ? '*' : '0'+ButtonPtr->button, ButtonPtr->button );
        XClearWindow( display, window );
        XDrawString( display, window, wingc, 10,40,
                       MagellanBuffer, (int)strlen(MagellanBuffer) );
       };
      break;
      
     };
  };

 XCloseDevice( display, Device );
 XDestroyWindow( display, window );
 XCloseDisplay( display );
 return TRUE;
}
